/* Automatically generated by refactor.pl.
 *
 *
 * CMDNAME: banclear
 * CMDLEVEL: QCMD_AUTHED
 * CMDARGS: 1
 * CMDDESC: Removes all bans from a channel including persistent bans.
 * CMDFUNC: csc_dobanclear
 * CMDPROTO: int csc_dobanclear(void *source, int cargc, char **cargv);
 * CMDHELP: Usage: BANCLEAR <channel>
 * CMDHELP: Removes all temporary and persistent bans from a channel, where:
 * CMDHELP: channel - the channel to use
 * CMDHELP: BANCLEAR requires master (+m) access on the named channel.
 */

#include "../chanserv.h"
#include "../../nick/nick.h"
#include "../../lib/flags.h"
#include "../../lib/irc_string.h"
#include "../../channel/channel.h"
#include "../../parser/parser.h"
#include "../../irc/irc.h"
#include "../../localuser/localuserchannel.h"
#include <string.h>
#include <stdio.h>

int csc_dobanclear(void *source, int cargc, char **cargv) {
  nick *sender=source;
  chanindex *cip;
  regban **rbh, *rbp;
  chanban **cbh, *cbp;
  regchan *rcp;
  modechanges changes;
  char *banstr;

  if (cargc<1) {
    chanservstdmessage(sender, QM_NOTENOUGHPARAMS, "banclear");
    return CMD_ERROR;
  }

  if (!(cip=cs_checkaccess(sender, cargv[0], CA_MASTERPRIV, NULL, "banclear", 0, 0)))
    return CMD_ERROR;

  rcp=cip->exts[chanservext];

  if (cip->channel)
    localsetmodeinit(&changes, cip->channel, chanservnick);
    
  for (rbh=&(rcp->bans); *rbh; ) {
    rbp=*rbh;
    banstr=bantostring(rbp->cbp);
    chanservstdmessage(sender, QM_REMOVEDPERMBAN, banstr, cip->name->content);
    if (cip->channel)
      localdosetmode_ban(&changes, banstr, MCB_DEL);
    /* Remove from database */
    csdb_deleteban(rbp);
    /* Remove from list */
    (*rbh)=rbp->next;
    /* Free ban/string and update setby refcount, and free actual regban */
    freesstring(rbp->reason);
    freechanban(rbp->cbp);
    freeregban(rbp);
  }

  if (cip->channel) {
    for (cbh=&(cip->channel->bans); *cbh; ) {
      cbp=*cbh;
      banstr=bantostring(cbp);
      chanservstdmessage(sender, QM_REMOVEDCHANBAN, banstr, cip->name->content);
      localdosetmode_ban(&changes, banstr, MCB_DEL);
    }
    localsetmodeflush(&changes,1);
  }
    
  chanservstdmessage(sender, QM_DONE);
  return CMD_OK;
}
