/* Automatically generated by refactor.pl.
 *
 *
 * CMDNAME: unbanme
 * CMDLEVEL: QCMD_AUTHED
 * CMDARGS: 1
 * CMDDESC: Removes any bans affecting you from a channel.
 * CMDFUNC: csc_dounbanme
 * CMDPROTO: int csc_dounbanme(void *source, int cargc, char **cargv);
 * CMDHELP: Usage: UNBANME <channel>
 * CMDHELP: This command removes any channel bans which affect you from a channel.  It does
 * CMDHELP: not affect persistent bans set by PERMBAN and TEMPBAN.  Where:
 * CMDHELP: channel - channel to use
 * CMDHELP: UNBANME requires operator (+o) access on the named channel.
 */

#include "../chanserv.h"
#include "../../nick/nick.h"
#include "../../lib/flags.h"
#include "../../lib/irc_string.h"
#include "../../channel/channel.h"
#include "../../parser/parser.h"
#include "../../irc/irc.h"
#include "../../localuser/localuserchannel.h"
#include <string.h>
#include <stdio.h>

static int nickmatchban_peerthroughhidehost(void *arg, struct chanban *ban) {
  return nickmatchban(arg, ban, 0);
}

int csc_dounbanme(void *source, int cargc, char **cargv) {
  nick *sender=source;
  chanindex *cip;
  
  if (cargc<1) {
    chanservstdmessage(sender, QM_NOTENOUGHPARAMS, "unbanme");
    return CMD_ERROR;
  }

  if (!(cip=cs_checkaccess(sender, cargv[0], CA_OPPRIV, NULL, "unbanme", 0, 0)))
    return CMD_ERROR;

  /* Try to unban, if it fails we'll let the failure message speak for itself */
  if (!cs_unbanfn(sender, cip, nickmatchban_peerthroughhidehost, sender, 1, 1)) {
    chanservstdmessage(sender, QM_DONE);
  }  

  cs_log(sender,"UNBANME %s",cip->name->content);
  return CMD_OK;
}     
