/* Automatically generated by refactor.pl.
 *
 *
 * CMDNAME: usercomment
 * CMDLEVEL: QCMD_OPER
 * CMDARGS: 2
 * CMDDESC: Shows or changes staff comment for a user.
 * CMDFUNC: csu_dousercomment
 * CMDPROTO: int csu_dousercomment(void *source, int cargc, char **cargv);
 * CMDHELP: Usage: usercomment <username> [[+]<comment>]
 * CMDHELP: Shows or changes the staff comment for the specified user.
 * CMDHELP: Comments can be appended to by prefixing <comment> with +.
 * CMDHELP: Use 'none' for <comment> to unset.
 */

#include "../chanserv.h"
#include "../../lib/irc_string.h"
#include <stdio.h>
#include <string.h>

int csu_dousercomment(void *source, int cargc, char **cargv) {
  nick *sender=source;
  reguser *rup=getreguserfromnick(sender), *target;
  char buf[300];
  int bufpos;

  if (!rup)
    return CMD_ERROR;

  if (cargc<1) {
    chanservstdmessage(sender, QM_NOTENOUGHPARAMS, "usercomment");
    return CMD_ERROR;
  }

  if (!(target=findreguser(sender, cargv[0])))
    return CMD_ERROR;

  if (cargc>1) {
    if (!ircd_strcmp(cargv[1],"none")) {
      freesstring(target->comment);
      target->comment=NULL;
    } else {
      if (*cargv[1]=='+') {
	if (target->comment) {
	  strcpy(buf,target->comment->content);
	  bufpos=target->comment->length;
	  buf[bufpos++]=' ';
	} else {
	  bufpos=0;
	}
	strncpy(buf+bufpos, cargv[1]+1, 280-bufpos);
      } else {
	strncpy(buf, cargv[1], 250);
      }
    
      freesstring(target->comment);
      target->comment=getsstring(buf,250);
    }
    csdb_updateuser(target);
  }
  
  if (target->comment) 
    chanservstdmessage(sender, QM_COMMENT, target->username, target->comment->content);
  else
    chanservstdmessage(sender, QM_NOCOMMENT, target->username);

  return CMD_OK;
}
